package com.hfkj.dao;

import com.hfkj.entity.BsGasOrder;
import com.hfkj.entity.BsGasOrderExample.Criteria;
import com.hfkj.entity.BsGasOrderExample.Criterion;
import com.hfkj.entity.BsGasOrderExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsGasOrderSqlProvider {

    public String countByExample(BsGasOrderExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_gas_order");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsGasOrderExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_gas_order");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsGasOrder record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_gas_order");
        
        if (record.getOrderNo() != null) {
            sql.VALUES("order_no", "#{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderChildNo() != null) {
            sql.VALUES("order_child_no", "#{orderChildNo,jdbcType=VARCHAR}");
        }
        
        if (record.getChannelType() != null) {
            sql.VALUES("channel_type", "#{channelType,jdbcType=INTEGER}");
        }
        
        if (record.getChannelOrderNo() != null) {
            sql.VALUES("channel_order_no", "#{channelOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAgentId() != null) {
            sql.VALUES("agent_id", "#{agentId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentName() != null) {
            sql.VALUES("agent_name", "#{agentName,jdbcType=VARCHAR}");
        }
        
        if (record.getAgentStaffId() != null) {
            sql.VALUES("agent_staff_id", "#{agentStaffId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentStaffName() != null) {
            sql.VALUES("agent_staff_name", "#{agentStaffName,jdbcType=VARCHAR}");
        }
        
        if (record.getUserId() != null) {
            sql.VALUES("user_id", "#{userId,jdbcType=BIGINT}");
        }
        
        if (record.getUserPhone() != null) {
            sql.VALUES("user_phone", "#{userPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getMerChainBrandId() != null) {
            sql.VALUES("mer_chain_brand_id", "#{merChainBrandId,jdbcType=BIGINT}");
        }
        
        if (record.getMerChainBrandName() != null) {
            sql.VALUES("mer_chain_brand_name", "#{merChainBrandName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerId() != null) {
            sql.VALUES("mer_id", "#{merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerNo() != null) {
            sql.VALUES("mer_no", "#{merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerName() != null) {
            sql.VALUES("mer_name", "#{merName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerAddress() != null) {
            sql.VALUES("mer_address", "#{merAddress,jdbcType=VARCHAR}");
        }
        
        if (record.getTotalDeductionPrice() != null) {
            sql.VALUES("total_deduction_price", "#{totalDeductionPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getDeductionCouponPrice() != null) {
            sql.VALUES("deduction_coupon_price", "#{deductionCouponPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getDeductionOilPrice() != null) {
            sql.VALUES("deduction_oil_price", "#{deductionOilPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPayIntegral() != null) {
            sql.VALUES("pay_integral", "#{payIntegral,jdbcType=BIGINT}");
        }
        
        if (record.getPayablePrice() != null) {
            sql.VALUES("payable_price", "#{payablePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getActualPayPrice() != null) {
            sql.VALUES("actual_pay_price", "#{actualPayPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGasRefuelPrice() != null) {
            sql.VALUES("gas_refuel_price", "#{gasRefuelPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGasSettlePrice() != null) {
            sql.VALUES("gas_settle_price", "#{gasSettlePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGasAgentSettlePrice() != null) {
            sql.VALUES("gas_agent_settle_price", "#{gasAgentSettlePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGasServiceFeeRate() != null) {
            sql.VALUES("gas_service_fee_rate", "#{gasServiceFeeRate,jdbcType=DECIMAL}");
        }
        
        if (record.getGasServiceFeePrice() != null) {
            sql.VALUES("gas_service_fee_price", "#{gasServiceFeePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGasOilNo() != null) {
            sql.VALUES("gas_oil_no", "#{gasOilNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGasGunNo() != null) {
            sql.VALUES("gas_gun_no", "#{gasGunNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGasOilType() != null) {
            sql.VALUES("gas_oil_type", "#{gasOilType,jdbcType=INTEGER}");
        }
        
        if (record.getGasPriceOfficial() != null) {
            sql.VALUES("gas_price_official", "#{gasPriceOfficial,jdbcType=DECIMAL}");
        }
        
        if (record.getGasPriceGun() != null) {
            sql.VALUES("gas_price_gun", "#{gasPriceGun,jdbcType=DECIMAL}");
        }
        
        if (record.getGasPriceVip() != null) {
            sql.VALUES("gas_price_vip", "#{gasPriceVip,jdbcType=DECIMAL}");
        }
        
        if (record.getGasPricePlatform() != null) {
            sql.VALUES("gas_price_platform", "#{gasPricePlatform,jdbcType=DECIMAL}");
        }
        
        if (record.getGasPriceCost() != null) {
            sql.VALUES("gas_price_cost", "#{gasPriceCost,jdbcType=DECIMAL}");
        }
        
        if (record.getGasOilLiters() != null) {
            sql.VALUES("gas_oil_liters", "#{gasOilLiters,jdbcType=DECIMAL}");
        }
        
        if (record.getGasDiscount() != null) {
            sql.VALUES("gas_discount", "#{gasDiscount,jdbcType=DECIMAL}");
        }
        
        if (record.getGasOilSubsidy() != null) {
            sql.VALUES("gas_oil_subsidy", "#{gasOilSubsidy,jdbcType=DECIMAL}");
        }
        
        if (record.getGasLitersPreferences() != null) {
            sql.VALUES("gas_liters_preferences", "#{gasLitersPreferences,jdbcType=DECIMAL}");
        }
        
        if (record.getGasPricePreferences() != null) {
            sql.VALUES("gas_price_preferences", "#{gasPricePreferences,jdbcType=DECIMAL}");
        }
        
        if (record.getGasClassGroupId() != null) {
            sql.VALUES("gas_class_group_id", "#{gasClassGroupId,jdbcType=BIGINT}");
        }
        
        if (record.getGasClassGroupName() != null) {
            sql.VALUES("gas_class_group_name", "#{gasClassGroupName,jdbcType=VARCHAR}");
        }
        
        if (record.getGasClassGroupTaskId() != null) {
            sql.VALUES("gas_class_group_task_id", "#{gasClassGroupTaskId,jdbcType=BIGINT}");
        }
        
        if (record.getGasStaffId() != null) {
            sql.VALUES("gas_staff_id", "#{gasStaffId,jdbcType=BIGINT}");
        }
        
        if (record.getGasStaffName() != null) {
            sql.VALUES("gas_staff_name", "#{gasStaffName,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiptStatus() != null) {
            sql.VALUES("receipt_status", "#{receiptStatus,jdbcType=INTEGER}");
        }
        
        if (record.getReceiptFailRemark() != null) {
            sql.VALUES("receipt_fail_remark", "#{receiptFailRemark,jdbcType=VARCHAR}");
        }
        
        if (record.getPayType() != null) {
            sql.VALUES("pay_type", "#{payType,jdbcType=INTEGER}");
        }
        
        if (record.getPaySerialNo() != null) {
            sql.VALUES("pay_serial_no", "#{paySerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPayChannelOrderNo() != null) {
            sql.VALUES("pay_channel_order_no", "#{payChannelOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateType() != null) {
            sql.VALUES("create_type", "#{createType,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCancelTime() != null) {
            sql.VALUES("cancel_time", "#{cancelTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getPayTime() != null) {
            sql.VALUES("pay_time", "#{payTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRefundTime() != null) {
            sql.VALUES("refund_time", "#{refundTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRefundRemarks() != null) {
            sql.VALUES("refund_remarks", "#{refundRemarks,jdbcType=VARCHAR}");
        }
        
        if (record.getAbnormal() != null) {
            sql.VALUES("abnormal", "#{abnormal,jdbcType=BIT}");
        }
        
        if (record.getAbnormalContent() != null) {
            sql.VALUES("abnormal_content", "#{abnormalContent,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getExt4() != null) {
            sql.VALUES("ext_4", "#{ext4,jdbcType=VARCHAR}");
        }
        
        if (record.getExt5() != null) {
            sql.VALUES("ext_5", "#{ext5,jdbcType=VARCHAR}");
        }
        
        if (record.getExt6() != null) {
            sql.VALUES("ext_6", "#{ext6,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsGasOrderExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("order_no");
        sql.SELECT("order_child_no");
        sql.SELECT("channel_type");
        sql.SELECT("channel_order_no");
        sql.SELECT("agent_id");
        sql.SELECT("agent_name");
        sql.SELECT("agent_staff_id");
        sql.SELECT("agent_staff_name");
        sql.SELECT("user_id");
        sql.SELECT("user_phone");
        sql.SELECT("mer_chain_brand_id");
        sql.SELECT("mer_chain_brand_name");
        sql.SELECT("mer_id");
        sql.SELECT("mer_no");
        sql.SELECT("mer_name");
        sql.SELECT("mer_address");
        sql.SELECT("total_deduction_price");
        sql.SELECT("deduction_coupon_price");
        sql.SELECT("deduction_oil_price");
        sql.SELECT("pay_integral");
        sql.SELECT("payable_price");
        sql.SELECT("actual_pay_price");
        sql.SELECT("gas_refuel_price");
        sql.SELECT("gas_settle_price");
        sql.SELECT("gas_agent_settle_price");
        sql.SELECT("gas_service_fee_rate");
        sql.SELECT("gas_service_fee_price");
        sql.SELECT("gas_oil_no");
        sql.SELECT("gas_gun_no");
        sql.SELECT("gas_oil_type");
        sql.SELECT("gas_price_official");
        sql.SELECT("gas_price_gun");
        sql.SELECT("gas_price_vip");
        sql.SELECT("gas_price_platform");
        sql.SELECT("gas_price_cost");
        sql.SELECT("gas_oil_liters");
        sql.SELECT("gas_discount");
        sql.SELECT("gas_oil_subsidy");
        sql.SELECT("gas_liters_preferences");
        sql.SELECT("gas_price_preferences");
        sql.SELECT("gas_class_group_id");
        sql.SELECT("gas_class_group_name");
        sql.SELECT("gas_class_group_task_id");
        sql.SELECT("gas_staff_id");
        sql.SELECT("gas_staff_name");
        sql.SELECT("receipt_status");
        sql.SELECT("receipt_fail_remark");
        sql.SELECT("pay_type");
        sql.SELECT("pay_serial_no");
        sql.SELECT("pay_channel_order_no");
        sql.SELECT("`status`");
        sql.SELECT("create_type");
        sql.SELECT("create_time");
        sql.SELECT("cancel_time");
        sql.SELECT("pay_time");
        sql.SELECT("refund_time");
        sql.SELECT("refund_remarks");
        sql.SELECT("abnormal");
        sql.SELECT("abnormal_content");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.SELECT("ext_4");
        sql.SELECT("ext_5");
        sql.SELECT("ext_6");
        sql.FROM("bs_gas_order");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsGasOrder record = (BsGasOrder) parameter.get("record");
        BsGasOrderExample example = (BsGasOrderExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_gas_order");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderChildNo() != null) {
            sql.SET("order_child_no = #{record.orderChildNo,jdbcType=VARCHAR}");
        }
        
        if (record.getChannelType() != null) {
            sql.SET("channel_type = #{record.channelType,jdbcType=INTEGER}");
        }
        
        if (record.getChannelOrderNo() != null) {
            sql.SET("channel_order_no = #{record.channelOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAgentId() != null) {
            sql.SET("agent_id = #{record.agentId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentName() != null) {
            sql.SET("agent_name = #{record.agentName,jdbcType=VARCHAR}");
        }
        
        if (record.getAgentStaffId() != null) {
            sql.SET("agent_staff_id = #{record.agentStaffId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentStaffName() != null) {
            sql.SET("agent_staff_name = #{record.agentStaffName,jdbcType=VARCHAR}");
        }
        
        if (record.getUserId() != null) {
            sql.SET("user_id = #{record.userId,jdbcType=BIGINT}");
        }
        
        if (record.getUserPhone() != null) {
            sql.SET("user_phone = #{record.userPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getMerChainBrandId() != null) {
            sql.SET("mer_chain_brand_id = #{record.merChainBrandId,jdbcType=BIGINT}");
        }
        
        if (record.getMerChainBrandName() != null) {
            sql.SET("mer_chain_brand_name = #{record.merChainBrandName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerNo() != null) {
            sql.SET("mer_no = #{record.merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerName() != null) {
            sql.SET("mer_name = #{record.merName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerAddress() != null) {
            sql.SET("mer_address = #{record.merAddress,jdbcType=VARCHAR}");
        }
        
        if (record.getTotalDeductionPrice() != null) {
            sql.SET("total_deduction_price = #{record.totalDeductionPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getDeductionCouponPrice() != null) {
            sql.SET("deduction_coupon_price = #{record.deductionCouponPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getDeductionOilPrice() != null) {
            sql.SET("deduction_oil_price = #{record.deductionOilPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPayIntegral() != null) {
            sql.SET("pay_integral = #{record.payIntegral,jdbcType=BIGINT}");
        }
        
        if (record.getPayablePrice() != null) {
            sql.SET("payable_price = #{record.payablePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getActualPayPrice() != null) {
            sql.SET("actual_pay_price = #{record.actualPayPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGasRefuelPrice() != null) {
            sql.SET("gas_refuel_price = #{record.gasRefuelPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGasSettlePrice() != null) {
            sql.SET("gas_settle_price = #{record.gasSettlePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGasAgentSettlePrice() != null) {
            sql.SET("gas_agent_settle_price = #{record.gasAgentSettlePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGasServiceFeeRate() != null) {
            sql.SET("gas_service_fee_rate = #{record.gasServiceFeeRate,jdbcType=DECIMAL}");
        }
        
        if (record.getGasServiceFeePrice() != null) {
            sql.SET("gas_service_fee_price = #{record.gasServiceFeePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGasOilNo() != null) {
            sql.SET("gas_oil_no = #{record.gasOilNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGasGunNo() != null) {
            sql.SET("gas_gun_no = #{record.gasGunNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGasOilType() != null) {
            sql.SET("gas_oil_type = #{record.gasOilType,jdbcType=INTEGER}");
        }
        
        if (record.getGasPriceOfficial() != null) {
            sql.SET("gas_price_official = #{record.gasPriceOfficial,jdbcType=DECIMAL}");
        }
        
        if (record.getGasPriceGun() != null) {
            sql.SET("gas_price_gun = #{record.gasPriceGun,jdbcType=DECIMAL}");
        }
        
        if (record.getGasPriceVip() != null) {
            sql.SET("gas_price_vip = #{record.gasPriceVip,jdbcType=DECIMAL}");
        }
        
        if (record.getGasPricePlatform() != null) {
            sql.SET("gas_price_platform = #{record.gasPricePlatform,jdbcType=DECIMAL}");
        }
        
        if (record.getGasPriceCost() != null) {
            sql.SET("gas_price_cost = #{record.gasPriceCost,jdbcType=DECIMAL}");
        }
        
        if (record.getGasOilLiters() != null) {
            sql.SET("gas_oil_liters = #{record.gasOilLiters,jdbcType=DECIMAL}");
        }
        
        if (record.getGasDiscount() != null) {
            sql.SET("gas_discount = #{record.gasDiscount,jdbcType=DECIMAL}");
        }
        
        if (record.getGasOilSubsidy() != null) {
            sql.SET("gas_oil_subsidy = #{record.gasOilSubsidy,jdbcType=DECIMAL}");
        }
        
        if (record.getGasLitersPreferences() != null) {
            sql.SET("gas_liters_preferences = #{record.gasLitersPreferences,jdbcType=DECIMAL}");
        }
        
        if (record.getGasPricePreferences() != null) {
            sql.SET("gas_price_preferences = #{record.gasPricePreferences,jdbcType=DECIMAL}");
        }
        
        if (record.getGasClassGroupId() != null) {
            sql.SET("gas_class_group_id = #{record.gasClassGroupId,jdbcType=BIGINT}");
        }
        
        if (record.getGasClassGroupName() != null) {
            sql.SET("gas_class_group_name = #{record.gasClassGroupName,jdbcType=VARCHAR}");
        }
        
        if (record.getGasClassGroupTaskId() != null) {
            sql.SET("gas_class_group_task_id = #{record.gasClassGroupTaskId,jdbcType=BIGINT}");
        }
        
        if (record.getGasStaffId() != null) {
            sql.SET("gas_staff_id = #{record.gasStaffId,jdbcType=BIGINT}");
        }
        
        if (record.getGasStaffName() != null) {
            sql.SET("gas_staff_name = #{record.gasStaffName,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiptStatus() != null) {
            sql.SET("receipt_status = #{record.receiptStatus,jdbcType=INTEGER}");
        }
        
        if (record.getReceiptFailRemark() != null) {
            sql.SET("receipt_fail_remark = #{record.receiptFailRemark,jdbcType=VARCHAR}");
        }
        
        if (record.getPayType() != null) {
            sql.SET("pay_type = #{record.payType,jdbcType=INTEGER}");
        }
        
        if (record.getPaySerialNo() != null) {
            sql.SET("pay_serial_no = #{record.paySerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPayChannelOrderNo() != null) {
            sql.SET("pay_channel_order_no = #{record.payChannelOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateType() != null) {
            sql.SET("create_type = #{record.createType,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCancelTime() != null) {
            sql.SET("cancel_time = #{record.cancelTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getPayTime() != null) {
            sql.SET("pay_time = #{record.payTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRefundTime() != null) {
            sql.SET("refund_time = #{record.refundTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRefundRemarks() != null) {
            sql.SET("refund_remarks = #{record.refundRemarks,jdbcType=VARCHAR}");
        }
        
        if (record.getAbnormal() != null) {
            sql.SET("abnormal = #{record.abnormal,jdbcType=BIT}");
        }
        
        if (record.getAbnormalContent() != null) {
            sql.SET("abnormal_content = #{record.abnormalContent,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getExt4() != null) {
            sql.SET("ext_4 = #{record.ext4,jdbcType=VARCHAR}");
        }
        
        if (record.getExt5() != null) {
            sql.SET("ext_5 = #{record.ext5,jdbcType=VARCHAR}");
        }
        
        if (record.getExt6() != null) {
            sql.SET("ext_6 = #{record.ext6,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_gas_order");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        sql.SET("order_child_no = #{record.orderChildNo,jdbcType=VARCHAR}");
        sql.SET("channel_type = #{record.channelType,jdbcType=INTEGER}");
        sql.SET("channel_order_no = #{record.channelOrderNo,jdbcType=VARCHAR}");
        sql.SET("agent_id = #{record.agentId,jdbcType=BIGINT}");
        sql.SET("agent_name = #{record.agentName,jdbcType=VARCHAR}");
        sql.SET("agent_staff_id = #{record.agentStaffId,jdbcType=BIGINT}");
        sql.SET("agent_staff_name = #{record.agentStaffName,jdbcType=VARCHAR}");
        sql.SET("user_id = #{record.userId,jdbcType=BIGINT}");
        sql.SET("user_phone = #{record.userPhone,jdbcType=VARCHAR}");
        sql.SET("mer_chain_brand_id = #{record.merChainBrandId,jdbcType=BIGINT}");
        sql.SET("mer_chain_brand_name = #{record.merChainBrandName,jdbcType=VARCHAR}");
        sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        sql.SET("mer_no = #{record.merNo,jdbcType=VARCHAR}");
        sql.SET("mer_name = #{record.merName,jdbcType=VARCHAR}");
        sql.SET("mer_address = #{record.merAddress,jdbcType=VARCHAR}");
        sql.SET("total_deduction_price = #{record.totalDeductionPrice,jdbcType=DECIMAL}");
        sql.SET("deduction_coupon_price = #{record.deductionCouponPrice,jdbcType=DECIMAL}");
        sql.SET("deduction_oil_price = #{record.deductionOilPrice,jdbcType=DECIMAL}");
        sql.SET("pay_integral = #{record.payIntegral,jdbcType=BIGINT}");
        sql.SET("payable_price = #{record.payablePrice,jdbcType=DECIMAL}");
        sql.SET("actual_pay_price = #{record.actualPayPrice,jdbcType=DECIMAL}");
        sql.SET("gas_refuel_price = #{record.gasRefuelPrice,jdbcType=DECIMAL}");
        sql.SET("gas_settle_price = #{record.gasSettlePrice,jdbcType=DECIMAL}");
        sql.SET("gas_agent_settle_price = #{record.gasAgentSettlePrice,jdbcType=DECIMAL}");
        sql.SET("gas_service_fee_rate = #{record.gasServiceFeeRate,jdbcType=DECIMAL}");
        sql.SET("gas_service_fee_price = #{record.gasServiceFeePrice,jdbcType=DECIMAL}");
        sql.SET("gas_oil_no = #{record.gasOilNo,jdbcType=VARCHAR}");
        sql.SET("gas_gun_no = #{record.gasGunNo,jdbcType=VARCHAR}");
        sql.SET("gas_oil_type = #{record.gasOilType,jdbcType=INTEGER}");
        sql.SET("gas_price_official = #{record.gasPriceOfficial,jdbcType=DECIMAL}");
        sql.SET("gas_price_gun = #{record.gasPriceGun,jdbcType=DECIMAL}");
        sql.SET("gas_price_vip = #{record.gasPriceVip,jdbcType=DECIMAL}");
        sql.SET("gas_price_platform = #{record.gasPricePlatform,jdbcType=DECIMAL}");
        sql.SET("gas_price_cost = #{record.gasPriceCost,jdbcType=DECIMAL}");
        sql.SET("gas_oil_liters = #{record.gasOilLiters,jdbcType=DECIMAL}");
        sql.SET("gas_discount = #{record.gasDiscount,jdbcType=DECIMAL}");
        sql.SET("gas_oil_subsidy = #{record.gasOilSubsidy,jdbcType=DECIMAL}");
        sql.SET("gas_liters_preferences = #{record.gasLitersPreferences,jdbcType=DECIMAL}");
        sql.SET("gas_price_preferences = #{record.gasPricePreferences,jdbcType=DECIMAL}");
        sql.SET("gas_class_group_id = #{record.gasClassGroupId,jdbcType=BIGINT}");
        sql.SET("gas_class_group_name = #{record.gasClassGroupName,jdbcType=VARCHAR}");
        sql.SET("gas_class_group_task_id = #{record.gasClassGroupTaskId,jdbcType=BIGINT}");
        sql.SET("gas_staff_id = #{record.gasStaffId,jdbcType=BIGINT}");
        sql.SET("gas_staff_name = #{record.gasStaffName,jdbcType=VARCHAR}");
        sql.SET("receipt_status = #{record.receiptStatus,jdbcType=INTEGER}");
        sql.SET("receipt_fail_remark = #{record.receiptFailRemark,jdbcType=VARCHAR}");
        sql.SET("pay_type = #{record.payType,jdbcType=INTEGER}");
        sql.SET("pay_serial_no = #{record.paySerialNo,jdbcType=VARCHAR}");
        sql.SET("pay_channel_order_no = #{record.payChannelOrderNo,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("create_type = #{record.createType,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("cancel_time = #{record.cancelTime,jdbcType=TIMESTAMP}");
        sql.SET("pay_time = #{record.payTime,jdbcType=TIMESTAMP}");
        sql.SET("refund_time = #{record.refundTime,jdbcType=TIMESTAMP}");
        sql.SET("refund_remarks = #{record.refundRemarks,jdbcType=VARCHAR}");
        sql.SET("abnormal = #{record.abnormal,jdbcType=BIT}");
        sql.SET("abnormal_content = #{record.abnormalContent,jdbcType=VARCHAR}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        sql.SET("ext_4 = #{record.ext4,jdbcType=VARCHAR}");
        sql.SET("ext_5 = #{record.ext5,jdbcType=VARCHAR}");
        sql.SET("ext_6 = #{record.ext6,jdbcType=VARCHAR}");
        
        BsGasOrderExample example = (BsGasOrderExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsGasOrder record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_gas_order");
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderChildNo() != null) {
            sql.SET("order_child_no = #{orderChildNo,jdbcType=VARCHAR}");
        }
        
        if (record.getChannelType() != null) {
            sql.SET("channel_type = #{channelType,jdbcType=INTEGER}");
        }
        
        if (record.getChannelOrderNo() != null) {
            sql.SET("channel_order_no = #{channelOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAgentId() != null) {
            sql.SET("agent_id = #{agentId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentName() != null) {
            sql.SET("agent_name = #{agentName,jdbcType=VARCHAR}");
        }
        
        if (record.getAgentStaffId() != null) {
            sql.SET("agent_staff_id = #{agentStaffId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentStaffName() != null) {
            sql.SET("agent_staff_name = #{agentStaffName,jdbcType=VARCHAR}");
        }
        
        if (record.getUserId() != null) {
            sql.SET("user_id = #{userId,jdbcType=BIGINT}");
        }
        
        if (record.getUserPhone() != null) {
            sql.SET("user_phone = #{userPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getMerChainBrandId() != null) {
            sql.SET("mer_chain_brand_id = #{merChainBrandId,jdbcType=BIGINT}");
        }
        
        if (record.getMerChainBrandName() != null) {
            sql.SET("mer_chain_brand_name = #{merChainBrandName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerNo() != null) {
            sql.SET("mer_no = #{merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerName() != null) {
            sql.SET("mer_name = #{merName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerAddress() != null) {
            sql.SET("mer_address = #{merAddress,jdbcType=VARCHAR}");
        }
        
        if (record.getTotalDeductionPrice() != null) {
            sql.SET("total_deduction_price = #{totalDeductionPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getDeductionCouponPrice() != null) {
            sql.SET("deduction_coupon_price = #{deductionCouponPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getDeductionOilPrice() != null) {
            sql.SET("deduction_oil_price = #{deductionOilPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPayIntegral() != null) {
            sql.SET("pay_integral = #{payIntegral,jdbcType=BIGINT}");
        }
        
        if (record.getPayablePrice() != null) {
            sql.SET("payable_price = #{payablePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getActualPayPrice() != null) {
            sql.SET("actual_pay_price = #{actualPayPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGasRefuelPrice() != null) {
            sql.SET("gas_refuel_price = #{gasRefuelPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGasSettlePrice() != null) {
            sql.SET("gas_settle_price = #{gasSettlePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGasAgentSettlePrice() != null) {
            sql.SET("gas_agent_settle_price = #{gasAgentSettlePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGasServiceFeeRate() != null) {
            sql.SET("gas_service_fee_rate = #{gasServiceFeeRate,jdbcType=DECIMAL}");
        }
        
        if (record.getGasServiceFeePrice() != null) {
            sql.SET("gas_service_fee_price = #{gasServiceFeePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGasOilNo() != null) {
            sql.SET("gas_oil_no = #{gasOilNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGasGunNo() != null) {
            sql.SET("gas_gun_no = #{gasGunNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGasOilType() != null) {
            sql.SET("gas_oil_type = #{gasOilType,jdbcType=INTEGER}");
        }
        
        if (record.getGasPriceOfficial() != null) {
            sql.SET("gas_price_official = #{gasPriceOfficial,jdbcType=DECIMAL}");
        }
        
        if (record.getGasPriceGun() != null) {
            sql.SET("gas_price_gun = #{gasPriceGun,jdbcType=DECIMAL}");
        }
        
        if (record.getGasPriceVip() != null) {
            sql.SET("gas_price_vip = #{gasPriceVip,jdbcType=DECIMAL}");
        }
        
        if (record.getGasPricePlatform() != null) {
            sql.SET("gas_price_platform = #{gasPricePlatform,jdbcType=DECIMAL}");
        }
        
        if (record.getGasPriceCost() != null) {
            sql.SET("gas_price_cost = #{gasPriceCost,jdbcType=DECIMAL}");
        }
        
        if (record.getGasOilLiters() != null) {
            sql.SET("gas_oil_liters = #{gasOilLiters,jdbcType=DECIMAL}");
        }
        
        if (record.getGasDiscount() != null) {
            sql.SET("gas_discount = #{gasDiscount,jdbcType=DECIMAL}");
        }
        
        if (record.getGasOilSubsidy() != null) {
            sql.SET("gas_oil_subsidy = #{gasOilSubsidy,jdbcType=DECIMAL}");
        }
        
        if (record.getGasLitersPreferences() != null) {
            sql.SET("gas_liters_preferences = #{gasLitersPreferences,jdbcType=DECIMAL}");
        }
        
        if (record.getGasPricePreferences() != null) {
            sql.SET("gas_price_preferences = #{gasPricePreferences,jdbcType=DECIMAL}");
        }
        
        if (record.getGasClassGroupId() != null) {
            sql.SET("gas_class_group_id = #{gasClassGroupId,jdbcType=BIGINT}");
        }
        
        if (record.getGasClassGroupName() != null) {
            sql.SET("gas_class_group_name = #{gasClassGroupName,jdbcType=VARCHAR}");
        }
        
        if (record.getGasClassGroupTaskId() != null) {
            sql.SET("gas_class_group_task_id = #{gasClassGroupTaskId,jdbcType=BIGINT}");
        }
        
        if (record.getGasStaffId() != null) {
            sql.SET("gas_staff_id = #{gasStaffId,jdbcType=BIGINT}");
        }
        
        if (record.getGasStaffName() != null) {
            sql.SET("gas_staff_name = #{gasStaffName,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiptStatus() != null) {
            sql.SET("receipt_status = #{receiptStatus,jdbcType=INTEGER}");
        }
        
        if (record.getReceiptFailRemark() != null) {
            sql.SET("receipt_fail_remark = #{receiptFailRemark,jdbcType=VARCHAR}");
        }
        
        if (record.getPayType() != null) {
            sql.SET("pay_type = #{payType,jdbcType=INTEGER}");
        }
        
        if (record.getPaySerialNo() != null) {
            sql.SET("pay_serial_no = #{paySerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPayChannelOrderNo() != null) {
            sql.SET("pay_channel_order_no = #{payChannelOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateType() != null) {
            sql.SET("create_type = #{createType,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCancelTime() != null) {
            sql.SET("cancel_time = #{cancelTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getPayTime() != null) {
            sql.SET("pay_time = #{payTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRefundTime() != null) {
            sql.SET("refund_time = #{refundTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRefundRemarks() != null) {
            sql.SET("refund_remarks = #{refundRemarks,jdbcType=VARCHAR}");
        }
        
        if (record.getAbnormal() != null) {
            sql.SET("abnormal = #{abnormal,jdbcType=BIT}");
        }
        
        if (record.getAbnormalContent() != null) {
            sql.SET("abnormal_content = #{abnormalContent,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getExt4() != null) {
            sql.SET("ext_4 = #{ext4,jdbcType=VARCHAR}");
        }
        
        if (record.getExt5() != null) {
            sql.SET("ext_5 = #{ext5,jdbcType=VARCHAR}");
        }
        
        if (record.getExt6() != null) {
            sql.SET("ext_6 = #{ext6,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsGasOrderExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}